/*
 * zame-js-z80
 * Copyright 2010, Slava Tretyak
 */

OP_NOP			(Cpu_op_ED_00, DO_PREF_00)									// NOP
OP_LD_RP_NN		(Cpu_op_ED_01, this.SET_BC, GET_BC, DO_PREF_00)				// LD BC,NN
OP_LD_MRP_A		(Cpu_op_ED_02, GET_BC, DO_PREF_00)							// LD (BC),A
OP_DO_RP		(Cpu_op_ED_03, DO_INC_16, this.SET_BC, GET_BC, DO_PREF_00)	// INC BC
OP_DO_R			(Cpu_op_ED_04, DO_INC_8, REG_B, DO_PREF_00)					// INC B
OP_DO_R			(Cpu_op_ED_05, DO_DEC_8, REG_B, DO_PREF_00)					// DEC B
OP_LD_R_N		(Cpu_op_ED_06, REG_B, DO_PREF_00)							// LD B,N
OP_RLCA			(Cpu_op_ED_07, DO_PREF_00)									// RLCA
OP_EX_AF_AF_	(Cpu_op_ED_08, DO_PREF_00)									// EX AF,AF'
OP_ADD_RP_RP	(Cpu_op_ED_09, this.SET_HL, GET_HL, GET_BC, DO_PREF_00)		// ADD HL,BC
OP_LD_A_MRP		(Cpu_op_ED_0A, GET_BC, DO_PREF_00)							// LD A,(BC)
OP_DO_RP		(Cpu_op_ED_0B, DO_DEC_16, this.SET_BC, GET_BC, DO_PREF_00)	// DEC BC
OP_DO_R			(Cpu_op_ED_0C, DO_INC_8, REG_C, DO_PREF_00)					// INC C
OP_DO_R			(Cpu_op_ED_0D, DO_DEC_8, REG_C, DO_PREF_00)					// DEC C
OP_LD_R_N		(Cpu_op_ED_0E, REG_C, DO_PREF_00)							// LD C,N
OP_RRCA			(Cpu_op_ED_0F, DO_PREF_00)									// RRCA

OP_DJNZ			(Cpu_op_ED_10, DO_PREF_00)									// DJNZ
OP_LD_RP_NN		(Cpu_op_ED_11, this.SET_DE, GET_DE, DO_PREF_00)				// LD DE,NN
OP_LD_MRP_A		(Cpu_op_ED_12, GET_DE, DO_PREF_00)							// LD (DE),A
OP_DO_RP		(Cpu_op_ED_13, DO_INC_16, this.SET_DE, GET_DE, DO_PREF_00)	// INC DE
OP_DO_R			(Cpu_op_ED_14, DO_INC_8, REG_D, DO_PREF_00)					// INC D
OP_DO_R			(Cpu_op_ED_15, DO_DEC_8, REG_D, DO_PREF_00)					// DEC D
OP_LD_R_N		(Cpu_op_ED_16, REG_D, DO_PREF_00)							// LD D,N
OP_RLA			(Cpu_op_ED_17, DO_PREF_00)									// RLA
OP_JR			(Cpu_op_ED_18, DO_PREF_00)									// JR O
OP_ADD_RP_RP	(Cpu_op_ED_19, this.SET_HL, GET_HL, GET_DE, DO_PREF_00)		// ADD HL,DE
OP_LD_A_MRP		(Cpu_op_ED_1A, GET_DE, DO_PREF_00)							// LD A,(DE)
OP_DO_RP		(Cpu_op_ED_1B, DO_DEC_16, this.SET_DE, GET_DE, DO_PREF_00)	// DEC DE
OP_DO_R			(Cpu_op_ED_1C, DO_INC_8, REG_E, DO_PREF_00)					// INC E
OP_DO_R			(Cpu_op_ED_1D, DO_DEC_8, REG_E, DO_PREF_00)					// DEC E
OP_LD_R_N		(Cpu_op_ED_1E, REG_E, DO_PREF_00)							// LD E,N
OP_RRA			(Cpu_op_ED_1F, DO_PREF_00)									// RRA

OP_JR_CC		(Cpu_op_ED_20, CC_NZ, DO_PREF_00)							// JR NZ,O
OP_LD_RP_NN		(Cpu_op_ED_21, this.SET_HL, GET_HL, DO_PREF_00)				// LD HL,NN
OP_LD_MNN_RP	(Cpu_op_ED_22, REG_L, REG_H, DO_PREF_00)					// LD (NN),HL
OP_DO_RP		(Cpu_op_ED_23, DO_INC_16, this.SET_HL, GET_HL, DO_PREF_00)	// INC HL
OP_DO_R			(Cpu_op_ED_24, DO_INC_8, REG_H, DO_PREF_00)					// INC H
OP_DO_R			(Cpu_op_ED_25, DO_DEC_8, REG_H, DO_PREF_00)					// DEC H
OP_LD_R_N		(Cpu_op_ED_26, REG_H, DO_PREF_00)							// LD H,N
OP_DAA			(Cpu_op_ED_27, DO_PREF_00)									// DAA
OP_JR_CC		(Cpu_op_ED_28, CC_Z, DO_PREF_00)							// JR Z,O
OP_ADD_RP_RP	(Cpu_op_ED_29, this.SET_HL, GET_HL, GET_HL, DO_PREF_00)		// ADD HL,HL
OP_LD_RP_MNN	(Cpu_op_ED_2A, REG_L, REG_H, DO_PREF_00)					// LD HL,(NN)
OP_DO_RP		(Cpu_op_ED_2B, DO_DEC_16, this.SET_HL, GET_HL, DO_PREF_00)	// DEC HL
OP_DO_R			(Cpu_op_ED_2C, DO_INC_8, REG_L, DO_PREF_00)					// INC L
OP_DO_R			(Cpu_op_ED_2D, DO_DEC_8, REG_L, DO_PREF_00)					// DEC L
OP_LD_R_N		(Cpu_op_ED_2E, REG_L, DO_PREF_00)							// LD L,N
OP_CPL			(Cpu_op_ED_2F, DO_PREF_00)									// CPL

OP_JR_CC		(Cpu_op_ED_30, CC_NC, DO_PREF_00)							// JR NC,O
OP_LD_RP_NN		(Cpu_op_ED_31, this.SET_SP, GET_SP, DO_PREF_00)				// LD SP,NN
OP_LD_MNN_A		(Cpu_op_ED_32, DO_PREF_00)									// LD (NN),A
OP_DO_RP		(Cpu_op_ED_33, DO_INC_16, this.SET_SP, GET_SP, DO_PREF_00)	// INC SP
OP_DO_MHL		(Cpu_op_ED_34, DO_INC_8, DO_PREF_00)						// INC (HL)
OP_DO_MHL		(Cpu_op_ED_35, DO_DEC_8, DO_PREF_00)						// DEC (HL)
OP_LD_MHL_N		(Cpu_op_ED_36, DO_PREF_00)									// LD (HL),N
OP_SCF			(Cpu_op_ED_37, DO_PREF_00)									// SCF
OP_JR_CC		(Cpu_op_ED_38, CC_C, DO_PREF_00)							// JR C,O
OP_ADD_RP_RP	(Cpu_op_ED_39, this.SET_HL, GET_HL, GET_SP, DO_PREF_00)		// ADD HL,SP
OP_LD_A_MNN		(Cpu_op_ED_3A, DO_PREF_00)									// LD A,(NN)
OP_DO_RP		(Cpu_op_ED_3B, DO_DEC_16, this.SET_SP, GET_SP, DO_PREF_00)	// DEC SP
OP_DO_R			(Cpu_op_ED_3C, DO_INC_8, REG_A, DO_PREF_00)					// INC A
OP_DO_R			(Cpu_op_ED_3D, DO_DEC_8, REG_A, DO_PREF_00)					// DEC A
OP_LD_R_N		(Cpu_op_ED_3E, REG_A, DO_PREF_00)							// LD A,N
OP_CCF			(Cpu_op_ED_3F, DO_PREF_00)									// CCF

OP_IN_R_BC_P00		(Cpu_op_ED_40, REG_B)									// IN B,(C)
OP_OUT_BC_R_P00		(Cpu_op_ED_41, REG_B)									// OUT (C),B
OP_SBC_HL_RP_P00	(Cpu_op_ED_42, GET_BC)									// SBC HL,BC
OP_LD_MNN_RP		(Cpu_op_ED_43, REG_C, REG_B, DO_PREF_00)				// LD (NN),BC
OP_NEG_P00			(Cpu_op_ED_44)											// NEG
OP_RETN_P00			(Cpu_op_ED_45)											// RETN
OP_IM_P00			(Cpu_op_ED_46, 0)										// IM 0
OP_LD_I_A_P00		(Cpu_op_ED_47)											// LD I,A
OP_IN_R_BC_P00		(Cpu_op_ED_48, REG_C)									// IN C,(C)
OP_OUT_BC_R_P00		(Cpu_op_ED_49, REG_C)									// OUT (C),C
OP_ADC_HL_RP_P00	(Cpu_op_ED_4A, GET_BC)									// ADC HL,BC
OP_LD_RP_MNN		(Cpu_op_ED_4B, REG_C, REG_B, DO_PREF_00)				// LD BC,(NN)
OP_NEG_P00			(Cpu_op_ED_4C)											// NEG
OP_RETI_P00			(Cpu_op_ED_4D)											// RETI
OP_IM_P00			(Cpu_op_ED_4E, 0)										// IM 0
OP_LD_RR_A_P00		(Cpu_op_ED_4F)											// LD R,A

OP_IN_R_BC_P00		(Cpu_op_ED_50, REG_D)									// IN D,(C)
OP_OUT_BC_R_P00		(Cpu_op_ED_51, REG_D)									// OUT (C),D
OP_SBC_HL_RP_P00	(Cpu_op_ED_52, GET_DE)									// SBC HL,DE
OP_LD_MNN_RP		(Cpu_op_ED_53, REG_E, REG_D, DO_PREF_00)				// LD (NN),DE
OP_NEG_P00			(Cpu_op_ED_54)											// NEG
OP_RETN_P00			(Cpu_op_ED_55)											// RETN
OP_IM_P00			(Cpu_op_ED_56, 1)										// IM 1
OP_LD_A_I_P00		(Cpu_op_ED_57)											// LD A,I
OP_IN_R_BC_P00		(Cpu_op_ED_58, REG_E)									// IN E,(C)
OP_OUT_BC_R_P00		(Cpu_op_ED_59, REG_E)									// OUT (C),E
OP_ADC_HL_RP_P00	(Cpu_op_ED_5A, GET_DE)									// ADC HL,DE
OP_LD_RP_MNN		(Cpu_op_ED_5B, REG_E, REG_D, DO_PREF_00)				// LD DE,(NN)
OP_NEG_P00			(Cpu_op_ED_5C)											// NEG
OP_RETN_P00			(Cpu_op_ED_5D)											// RETN
OP_IM_P00			(Cpu_op_ED_5E, 2)										// IM 2
OP_LD_A_RR_P00		(Cpu_op_ED_5F)											// LD A,R

OP_IN_R_BC_P00		(Cpu_op_ED_60, REG_H)									// IN H,(C)
OP_OUT_BC_R_P00		(Cpu_op_ED_61, REG_H)									// OUT (H),D
OP_SBC_HL_RP_P00	(Cpu_op_ED_62, GET_HL)									// SBC HL,HL
OP_LD_MNN_RP		(Cpu_op_ED_63, REG_L, REG_H, DO_PREF_00)				// LD (NN),HL
OP_NEG_P00			(Cpu_op_ED_64)											// NEG
OP_RETN_P00			(Cpu_op_ED_65)											// RETN
OP_IM_P00			(Cpu_op_ED_66, 0)										// IM 0
OP_RRD_P00			(Cpu_op_ED_67)											// RRD
OP_IN_R_BC_P00		(Cpu_op_ED_68, REG_L)									// IN L,(C)
OP_OUT_BC_R_P00		(Cpu_op_ED_69, REG_L)									// OUT (C),L
OP_ADC_HL_RP_P00	(Cpu_op_ED_6A, GET_HL)									// ADC HL,HL
OP_LD_RP_MNN		(Cpu_op_ED_6B, REG_L, REG_H, DO_PREF_00)				// LD HL,(NN)
OP_NEG_P00			(Cpu_op_ED_6C)											// NEG
OP_RETN_P00			(Cpu_op_ED_6D)											// RETN
OP_IM_P00			(Cpu_op_ED_6E, 0)										// IM 0
OP_RLD_P00			(Cpu_op_ED_6F)											// RLD

OP_IN_F_BC_P00		(Cpu_op_ED_70)											// IN F,(C)
OP_OUT_BC_0_P00		(Cpu_op_ED_71)											// OUT (C),0
OP_SBC_HL_RP_P00	(Cpu_op_ED_72, GET_SP)									// SBC HL,SP
OP_LD_MNN_RP		(Cpu_op_ED_73, REG_SPL, REG_SPH, DO_PREF_00)			// LD (NN),SP
OP_NEG_P00			(Cpu_op_ED_74)											// NEG
OP_RETN_P00			(Cpu_op_ED_75)											// RETN
OP_IM_P00			(Cpu_op_ED_76, 1)										// IM 1
OP_LD_MRP_R			(Cpu_op_ED_77, GET_HL, REG_A, DO_PREF_00)				// LD (HL),A
OP_IN_R_BC_P00		(Cpu_op_ED_78, REG_A)									// IN A,(C)
OP_OUT_BC_R_P00		(Cpu_op_ED_79, REG_A)									// OUT (C),A
OP_ADC_HL_RP_P00	(Cpu_op_ED_7A, GET_SP)									// ADC HL,SP
OP_LD_RP_MNN		(Cpu_op_ED_7B, REG_SPL, REG_SPH, DO_PREF_00)			// LD SP,(NN)
OP_NEG_P00			(Cpu_op_ED_7C)											// NEG
OP_RETN_P00			(Cpu_op_ED_7D)											// RETN
OP_IM_P00			(Cpu_op_ED_7E, 2)										// IM 2
OP_LD_R_R			(Cpu_op_ED_7F, REG_A, REG_A, DO_PREF_00)				// LD A,A

OP_DO_A_R		(Cpu_op_ED_80, DO_ADD_8, REG_B, DO_PREF_00)					// ADD A,B
OP_DO_A_R		(Cpu_op_ED_81, DO_ADD_8, REG_C, DO_PREF_00)					// ADD A,C
OP_DO_A_R		(Cpu_op_ED_82, DO_ADD_8, REG_D, DO_PREF_00)					// ADD A,D
OP_DO_A_R		(Cpu_op_ED_83, DO_ADD_8, REG_E, DO_PREF_00)					// ADD A,E
OP_DO_A_R		(Cpu_op_ED_84, DO_ADD_8, REG_H, DO_PREF_00)					// ADD A,H
OP_DO_A_R		(Cpu_op_ED_85, DO_ADD_8, REG_L, DO_PREF_00)					// ADD A,L
OP_DO_A_MHL		(Cpu_op_ED_86, DO_ADD_8, DO_PREF_00)						// ADD A,(HL)
OP_DO_A_R		(Cpu_op_ED_87, DO_ADD_8, REG_A, DO_PREF_00)					// ADD A,A
OP_DO_A_R		(Cpu_op_ED_88, DO_ADC_8, REG_B, DO_PREF_00)					// ADC A,B
OP_DO_A_R		(Cpu_op_ED_89, DO_ADC_8, REG_C, DO_PREF_00)					// ADC A,C
OP_DO_A_R		(Cpu_op_ED_8A, DO_ADC_8, REG_D, DO_PREF_00)					// ADC A,D
OP_DO_A_R		(Cpu_op_ED_8B, DO_ADC_8, REG_E, DO_PREF_00)					// ADC A,E
OP_DO_A_R		(Cpu_op_ED_8C, DO_ADC_8, REG_H, DO_PREF_00)					// ADC A,H
OP_DO_A_R		(Cpu_op_ED_8D, DO_ADC_8, REG_L, DO_PREF_00)					// ADC A,L
OP_DO_A_MHL		(Cpu_op_ED_8E, DO_ADC_8, DO_PREF_00)						// ADC A,(HL)
OP_DO_A_R		(Cpu_op_ED_8F, DO_ADC_8, REG_A, DO_PREF_00)					// ADC A,A

OP_DO_A_R		(Cpu_op_ED_90, DO_SUB_8, REG_B, DO_PREF_00)					// SUB B
OP_DO_A_R		(Cpu_op_ED_91, DO_SUB_8, REG_C, DO_PREF_00)					// SUB C
OP_DO_A_R		(Cpu_op_ED_92, DO_SUB_8, REG_D, DO_PREF_00)					// SUB D
OP_DO_A_R		(Cpu_op_ED_93, DO_SUB_8, REG_E, DO_PREF_00)					// SUB E
OP_DO_A_R		(Cpu_op_ED_94, DO_SUB_8, REG_H, DO_PREF_00)					// SUB H
OP_DO_A_R		(Cpu_op_ED_95, DO_SUB_8, REG_L, DO_PREF_00)					// SUB L
OP_DO_A_MHL		(Cpu_op_ED_96, DO_SUB_8, DO_PREF_00)						// SUB (HL)
OP_DO_A_R		(Cpu_op_ED_97, DO_SUB_8, REG_A, DO_PREF_00)					// SUB A
OP_DO_A_R		(Cpu_op_ED_98, DO_SBC_8, REG_B, DO_PREF_00)					// SBC A,B
OP_DO_A_R		(Cpu_op_ED_99, DO_SBC_8, REG_C, DO_PREF_00)					// SBC A,C
OP_DO_A_R		(Cpu_op_ED_9A, DO_SBC_8, REG_D, DO_PREF_00)					// SBC A,D
OP_DO_A_R		(Cpu_op_ED_9B, DO_SBC_8, REG_E, DO_PREF_00)					// SBC A,E
OP_DO_A_R		(Cpu_op_ED_9C, DO_SBC_8, REG_H, DO_PREF_00)					// SBC A,H
OP_DO_A_R		(Cpu_op_ED_9D, DO_SBC_8, REG_L, DO_PREF_00)					// SBC A,L
OP_DO_A_MHL		(Cpu_op_ED_9E, DO_SBC_8, DO_PREF_00)						// SBC A,(HL)
OP_DO_A_R		(Cpu_op_ED_9F, DO_SBC_8, REG_A, DO_PREF_00)					// SBC A,A

OP_LDI_P00		(Cpu_op_ED_A0)												// LDI
OP_CPI_P00		(Cpu_op_ED_A1)												// CPI
OP_INI_P00		(Cpu_op_ED_A2)												// INI
OP_OUTI_P00		(Cpu_op_ED_A3)												// OUTI
OP_DO_A_R		(Cpu_op_ED_A4, DO_AND_8, REG_H, DO_PREF_00)					// AND H
OP_DO_A_R		(Cpu_op_ED_A5, DO_AND_8, REG_L, DO_PREF_00)					// AND L
OP_DO_A_MHL		(Cpu_op_ED_A6, DO_AND_8, DO_PREF_00)						// AND (HL)
OP_DO_A_R		(Cpu_op_ED_A7, DO_AND_8, REG_A, DO_PREF_00)					// AND A
OP_LDD_P00		(Cpu_op_ED_A8)												// LDD
OP_CPD_P00		(Cpu_op_ED_A9)												// CPD
OP_IND_P00		(Cpu_op_ED_AA)												// IND
OP_OUTD_P00		(Cpu_op_ED_AB)												// OUTD
OP_DO_A_R		(Cpu_op_ED_AC, DO_XOR_8, REG_H, DO_PREF_00)					// XOR H
OP_DO_A_R		(Cpu_op_ED_AD, DO_XOR_8, REG_L, DO_PREF_00)					// XOR L
OP_DO_A_MHL		(Cpu_op_ED_AE, DO_XOR_8, DO_PREF_00)						// XOR (HL)
OP_DO_A_R		(Cpu_op_ED_AF, DO_XOR_8, REG_A, DO_PREF_00)					// XOR A

OP_LDIR_P00		(Cpu_op_ED_B0)												// LDIR
OP_CPIR_P00		(Cpu_op_ED_B1)												// CPIR
OP_INIR_P00		(Cpu_op_ED_B2)												// INIR
OP_OTIR_P00		(Cpu_op_ED_B3)												// OTIR
OP_DO_A_R		(Cpu_op_ED_B4, DO_OR_8, REG_H, DO_PREF_00)					// OR H
OP_DO_A_R		(Cpu_op_ED_B5, DO_OR_8, REG_L, DO_PREF_00)					// OR L
OP_DO_A_MHL		(Cpu_op_ED_B6, DO_OR_8, DO_PREF_00)							// OR (HL)
OP_DO_A_R		(Cpu_op_ED_B7, DO_OR_8, REG_A, DO_PREF_00)					// OR A
OP_LDDR_P00		(Cpu_op_ED_B8)												// LDDR
OP_CPDR_P00		(Cpu_op_ED_B9)												// CPDR
OP_INDR_P00		(Cpu_op_ED_BA)												// INDR
OP_OTDR_P00		(Cpu_op_ED_BB)												// OTDR
OP_DO_A_R		(Cpu_op_ED_BC, DO_CP_8, REG_H, DO_PREF_00)					// CP H
OP_DO_A_R		(Cpu_op_ED_BD, DO_CP_8, REG_L, DO_PREF_00)					// CP L
OP_DO_A_MHL		(Cpu_op_ED_BE, DO_CP_8, DO_PREF_00)							// CP (HL)
OP_DO_A_R		(Cpu_op_ED_BF, DO_CP_8, REG_A, DO_PREF_00)					// CP A

OP_RET_CC		(Cpu_op_ED_C0, CC_NZ, DO_PREF_00)							// RET NZ
OP_POP_RP		(Cpu_op_ED_C1, this.SET_BC, GET_BC, DO_PREF_00)				// POP BC
OP_JP_CC		(Cpu_op_ED_C2, CC_NZ, DO_PREF_00)							// JP NZ,NN
OP_JP			(Cpu_op_ED_C3, DO_PREF_00)									// JP NN
OP_CALL_CC		(Cpu_op_ED_C4, CC_NZ, DO_PREF_00)							// CALL NZ,NN
OP_PUSH_RP		(Cpu_op_ED_C5, GET_BC, DO_PREF_00)							// PUSH BC
OP_DO_A_N		(Cpu_op_ED_C6, DO_ADD_8, DO_PREF_00)						// ADD A,N
OP_RST			(Cpu_op_ED_C7, 0x00, DO_PREF_00)							// RST #00
OP_RET_CC		(Cpu_op_ED_C8, CC_Z, DO_PREF_00)							// RET Z
OP_RET			(Cpu_op_ED_C9, DO_PREF_00)									// RET
OP_JP_CC		(Cpu_op_ED_CA, CC_Z, DO_PREF_00)							// JP Z,NN
OP_PREF_CB		(Cpu_op_ED_CB)												// prefix #CB
OP_CALL_CC		(Cpu_op_ED_CC, CC_Z, DO_PREF_00)							// CALL Z,NN
OP_CALL			(Cpu_op_ED_CD, DO_PREF_00)									// CALL NN
OP_DO_A_N		(Cpu_op_ED_CE, DO_ADC_8, DO_PREF_00)						// ADC A,N
OP_RST			(Cpu_op_ED_CF, 0x08, DO_PREF_00)							// RST #08

OP_RET_CC		(Cpu_op_ED_D0, CC_NC, DO_PREF_00)							// RET NC
OP_POP_RP		(Cpu_op_ED_D1, this.SET_DE, GET_DE, DO_PREF_00)				// POP DE
OP_JP_CC		(Cpu_op_ED_D2, CC_NC, DO_PREF_00)							// JP NC,NN
OP_OUT_N_A		(Cpu_op_ED_D3, DO_PREF_00)									// OUT (N),A
OP_CALL_CC		(Cpu_op_ED_D4, CC_NC, DO_PREF_00)							// CALL NC,NN
OP_PUSH_RP		(Cpu_op_ED_D5, GET_DE, DO_PREF_00)							// PUSH DE
OP_DO_A_N		(Cpu_op_ED_D6, DO_SUB_8, DO_PREF_00)						// SUB N
OP_RST			(Cpu_op_ED_D7, 0x10, DO_PREF_00)							// RST #10
OP_RET_CC		(Cpu_op_ED_D8, CC_C, DO_PREF_00)							// RET C
OP_EXX			(Cpu_op_ED_D9, DO_PREF_00)									// EXX
OP_JP_CC		(Cpu_op_ED_DA, CC_C, DO_PREF_00)							// JP C,NN
OP_IN_A_N		(Cpu_op_ED_DB, DO_PREF_00)									// IN A,(N)
OP_CALL_CC		(Cpu_op_ED_DC, CC_C, DO_PREF_00)							// CALL C,NN
OP_PREF_DD		(Cpu_op_ED_DD)												// prefix #DD
OP_DO_A_N		(Cpu_op_ED_DE, DO_SBC_8, DO_PREF_00)						// SBC A,N
OP_RST			(Cpu_op_ED_DF, 0x18, DO_PREF_00)							// RST #18

OP_RET_CC		(Cpu_op_ED_E0, CC_PO, DO_PREF_00)							// RET PO
OP_POP_RP		(Cpu_op_ED_E1, this.SET_HL, GET_HL, DO_PREF_00)				// POP HL
OP_JP_CC		(Cpu_op_ED_E2, CC_PO, DO_PREF_00)							// JP PO,NN
OP_EX_SP_RP		(Cpu_op_ED_E3, REG_L, REG_H, this.SET_HL, DO_PREF_00)		// EX (SP),HL
OP_CALL_CC		(Cpu_op_ED_E4, CC_PO, DO_PREF_00)							// CALL PO,NN
OP_PUSH_RP		(Cpu_op_ED_E5, GET_HL, DO_PREF_00)							// PUSH HL
OP_DO_A_N		(Cpu_op_ED_E6, DO_AND_8, DO_PREF_00)						// AND N
OP_RST			(Cpu_op_ED_E7, 0x20, DO_PREF_00)							// RST #20
OP_RET_CC		(Cpu_op_ED_E8, CC_PE, DO_PREF_00)							// RET PE
OP_JP_RP		(Cpu_op_ED_E9, GET_HL, DO_PREF_00)							// JP HL
OP_JP_CC		(Cpu_op_ED_EA, CC_PE, DO_PREF_00)							// JP PE,NN
OP_EX_DE_HL		(Cpu_op_ED_EB, DO_PREF_00)									// EX DE,HL
OP_CALL_CC		(Cpu_op_ED_EC, CC_PE, DO_PREF_00)							// CALL PE,NN
OP_PREF_ED		(Cpu_op_ED_ED)												// prefix #ED
OP_DO_A_N		(Cpu_op_ED_EE, DO_XOR_8, DO_PREF_00)						// XOR N
OP_RST			(Cpu_op_ED_EF, 0x28, DO_PREF_00)							// RST #28

OP_RET_CC		(Cpu_op_ED_F0, CC_P, DO_PREF_00)							// RET P
OP_POP_RP		(Cpu_op_ED_F1, this.SET_AF, GET_AF, DO_PREF_00)				// POP AF
OP_JP_CC		(Cpu_op_ED_F2, CC_P, DO_PREF_00)							// JP P,NN
OP_DI			(Cpu_op_ED_F3, DO_PREF_00)									// DI
OP_CALL_CC		(Cpu_op_ED_F4, CC_P, DO_PREF_00)							// CALL P,NN
OP_PUSH_RP		(Cpu_op_ED_F5, GET_AF, DO_PREF_00)							// PUSH AF
OP_DO_A_N		(Cpu_op_ED_F6, DO_OR_8, DO_PREF_00)							// OR N
OP_RST			(Cpu_op_ED_F7, 0x30, DO_PREF_00)							// RST #30
OP_RET_CC		(Cpu_op_ED_F8, CC_M, DO_PREF_00)							// RET M
OP_LD_SP_RP		(Cpu_op_ED_F9, GET_HL, DO_PREF_00)							// LD SP,HL
OP_JP_CC		(Cpu_op_ED_FA, CC_M, DO_PREF_00)							// JP M,NN
OP_EI			(Cpu_op_ED_FB, DO_PREF_00)									// EI
OP_CALL_CC		(Cpu_op_ED_FC, CC_M, DO_PREF_00)							// CALL M,NN
OP_PREF_FD		(Cpu_op_ED_FD)												// prefix #FD
OP_DO_A_N		(Cpu_op_ED_FE, DO_CP_8, DO_PREF_00)							// CP N
OP_RST			(Cpu_op_ED_FF, 0x38, DO_PREF_00)							// RST #38

optable_ED = [
	Cpu_op_ED_00, Cpu_op_ED_01, Cpu_op_ED_02, Cpu_op_ED_03, Cpu_op_ED_04, Cpu_op_ED_05, Cpu_op_ED_06, Cpu_op_ED_07, Cpu_op_ED_08, Cpu_op_ED_09, Cpu_op_ED_0A, Cpu_op_ED_0B, Cpu_op_ED_0C, Cpu_op_ED_0D, Cpu_op_ED_0E, Cpu_op_ED_0F,
	Cpu_op_ED_10, Cpu_op_ED_11, Cpu_op_ED_12, Cpu_op_ED_13, Cpu_op_ED_14, Cpu_op_ED_15, Cpu_op_ED_16, Cpu_op_ED_17, Cpu_op_ED_18, Cpu_op_ED_19, Cpu_op_ED_1A, Cpu_op_ED_1B, Cpu_op_ED_1C, Cpu_op_ED_1D, Cpu_op_ED_1E, Cpu_op_ED_1F,
	Cpu_op_ED_20, Cpu_op_ED_21, Cpu_op_ED_22, Cpu_op_ED_23, Cpu_op_ED_24, Cpu_op_ED_25, Cpu_op_ED_26, Cpu_op_ED_27, Cpu_op_ED_28, Cpu_op_ED_29, Cpu_op_ED_2A, Cpu_op_ED_2B, Cpu_op_ED_2C, Cpu_op_ED_2D, Cpu_op_ED_2E, Cpu_op_ED_2F,
	Cpu_op_ED_30, Cpu_op_ED_31, Cpu_op_ED_32, Cpu_op_ED_33, Cpu_op_ED_34, Cpu_op_ED_35, Cpu_op_ED_36, Cpu_op_ED_37, Cpu_op_ED_38, Cpu_op_ED_39, Cpu_op_ED_3A, Cpu_op_ED_3B, Cpu_op_ED_3C, Cpu_op_ED_3D, Cpu_op_ED_3E, Cpu_op_ED_3F,
	Cpu_op_ED_40, Cpu_op_ED_41, Cpu_op_ED_42, Cpu_op_ED_43, Cpu_op_ED_44, Cpu_op_ED_45, Cpu_op_ED_46, Cpu_op_ED_47, Cpu_op_ED_48, Cpu_op_ED_49, Cpu_op_ED_4A, Cpu_op_ED_4B, Cpu_op_ED_4C, Cpu_op_ED_4D, Cpu_op_ED_4E, Cpu_op_ED_4F,
	Cpu_op_ED_50, Cpu_op_ED_51, Cpu_op_ED_52, Cpu_op_ED_53, Cpu_op_ED_54, Cpu_op_ED_55, Cpu_op_ED_56, Cpu_op_ED_57, Cpu_op_ED_58, Cpu_op_ED_59, Cpu_op_ED_5A, Cpu_op_ED_5B, Cpu_op_ED_5C, Cpu_op_ED_5D, Cpu_op_ED_5E, Cpu_op_ED_5F,
	Cpu_op_ED_60, Cpu_op_ED_61, Cpu_op_ED_62, Cpu_op_ED_63, Cpu_op_ED_64, Cpu_op_ED_65, Cpu_op_ED_66, Cpu_op_ED_67, Cpu_op_ED_68, Cpu_op_ED_69, Cpu_op_ED_6A, Cpu_op_ED_6B, Cpu_op_ED_6C, Cpu_op_ED_6D, Cpu_op_ED_6E, Cpu_op_ED_6F,
	Cpu_op_ED_70, Cpu_op_ED_71, Cpu_op_ED_72, Cpu_op_ED_73, Cpu_op_ED_74, Cpu_op_ED_75, Cpu_op_ED_76, Cpu_op_ED_77, Cpu_op_ED_78, Cpu_op_ED_79, Cpu_op_ED_7A, Cpu_op_ED_7B, Cpu_op_ED_7C, Cpu_op_ED_7D, Cpu_op_ED_7E, Cpu_op_ED_7F,
	Cpu_op_ED_80, Cpu_op_ED_81, Cpu_op_ED_82, Cpu_op_ED_83, Cpu_op_ED_84, Cpu_op_ED_85, Cpu_op_ED_86, Cpu_op_ED_87, Cpu_op_ED_88, Cpu_op_ED_89, Cpu_op_ED_8A, Cpu_op_ED_8B, Cpu_op_ED_8C, Cpu_op_ED_8D, Cpu_op_ED_8E, Cpu_op_ED_8F,
	Cpu_op_ED_90, Cpu_op_ED_91, Cpu_op_ED_92, Cpu_op_ED_93, Cpu_op_ED_94, Cpu_op_ED_95, Cpu_op_ED_96, Cpu_op_ED_97, Cpu_op_ED_98, Cpu_op_ED_99, Cpu_op_ED_9A, Cpu_op_ED_9B, Cpu_op_ED_9C, Cpu_op_ED_9D, Cpu_op_ED_9E, Cpu_op_ED_9F,
	Cpu_op_ED_A0, Cpu_op_ED_A1, Cpu_op_ED_A2, Cpu_op_ED_A3, Cpu_op_ED_A4, Cpu_op_ED_A5, Cpu_op_ED_A6, Cpu_op_ED_A7, Cpu_op_ED_A8, Cpu_op_ED_A9, Cpu_op_ED_AA, Cpu_op_ED_AB, Cpu_op_ED_AC, Cpu_op_ED_AD, Cpu_op_ED_AE, Cpu_op_ED_AF,
	Cpu_op_ED_B0, Cpu_op_ED_B1, Cpu_op_ED_B2, Cpu_op_ED_B3, Cpu_op_ED_B4, Cpu_op_ED_B5, Cpu_op_ED_B6, Cpu_op_ED_B7, Cpu_op_ED_B8, Cpu_op_ED_B9, Cpu_op_ED_BA, Cpu_op_ED_BB, Cpu_op_ED_BC, Cpu_op_ED_BD, Cpu_op_ED_BE, Cpu_op_ED_BF,
	Cpu_op_ED_C0, Cpu_op_ED_C1, Cpu_op_ED_C2, Cpu_op_ED_C3, Cpu_op_ED_C4, Cpu_op_ED_C5, Cpu_op_ED_C6, Cpu_op_ED_C7, Cpu_op_ED_C8, Cpu_op_ED_C9, Cpu_op_ED_CA, Cpu_op_ED_CB, Cpu_op_ED_CC, Cpu_op_ED_CD, Cpu_op_ED_CE, Cpu_op_ED_CF,
	Cpu_op_ED_D0, Cpu_op_ED_D1, Cpu_op_ED_D2, Cpu_op_ED_D3, Cpu_op_ED_D4, Cpu_op_ED_D5, Cpu_op_ED_D6, Cpu_op_ED_D7, Cpu_op_ED_D8, Cpu_op_ED_D9, Cpu_op_ED_DA, Cpu_op_ED_DB, Cpu_op_ED_DC, Cpu_op_ED_DD, Cpu_op_ED_DE, Cpu_op_ED_DF,
	Cpu_op_ED_E0, Cpu_op_ED_E1, Cpu_op_ED_E2, Cpu_op_ED_E3, Cpu_op_ED_E4, Cpu_op_ED_E5, Cpu_op_ED_E6, Cpu_op_ED_E7, Cpu_op_ED_E8, Cpu_op_ED_E9, Cpu_op_ED_EA, Cpu_op_ED_EB, Cpu_op_ED_EC, Cpu_op_ED_ED, Cpu_op_ED_EE, Cpu_op_ED_EF,
	Cpu_op_ED_F0, Cpu_op_ED_F1, Cpu_op_ED_F2, Cpu_op_ED_F3, Cpu_op_ED_F4, Cpu_op_ED_F5, Cpu_op_ED_F6, Cpu_op_ED_F7, Cpu_op_ED_F8, Cpu_op_ED_F9, Cpu_op_ED_FA, Cpu_op_ED_FB, Cpu_op_ED_FC, Cpu_op_ED_FD, Cpu_op_ED_FE, Cpu_op_ED_FF
];
